#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <unistd.h>
/* #include <sys/varargs.h> */
#include <time.h>
#include <stdarg.h>
#include <limits.h>
#include <stdlib.h>
#include "utility.h"
#ifdef __BORLANDC__
#include <process.h>
#endif

/*
#ifndef VA_START
//#include <sys/varargs.h>
#endif
*/

#define RANDOM_MAX INT_MAX


#ifdef __BORLANDC__
#undef random()
#define random() rand()
#endif

int die(char *msg, ...)
{
  va_list args;

  va_start(args, msg);
  vfprintf(stderr, msg, args);
  va_end(args);
  exit(1);
  return 1;
}

#ifndef __BORLANDC__
void randomize(void)
{
  srandom(time(0) + getpid());
}
#endif

double random_double(double low, double high)
{
  return random()/(RANDOM_MAX + 1.0) * (high-low) + low;
}

int random_int(int low, int high)
{
  return low + (int)((high - low + 1.0) * random()/(RANDOM_MAX + 1.0));
}

double random_normal(double mean, double variance) {
  static int iset = 0;
  static double gset;
  double fac, rsq, v1, v2;

  if(!iset) {
    do {
      v1 = random()/(RANDOM_MAX + 1.0) * 2.0 - 1.0;
      v2 = random()/(RANDOM_MAX + 1.0) * 2.0 - 1.0;
      rsq = v1 * v1 + v2 * v2;
    } while (rsq >= 1.0 || rsq == 0.0);
    fac = sqrt(-2.0 * log(rsq) / rsq);
    gset = v1 * fac;
    iset = 1;
    return v2 * fac * sqrt(variance) + mean;
  }
  else {
    iset = 0;
    return gset * sqrt(variance) + mean;
  }
}

double random_t(double mean, double variance, int df) {
  double numer, denom, tmp;
  int i;

  numer = random_normal(0.0, 1.0);
  denom = 0.0;
  for(i = 0; i < df; i++) {
    tmp = random_normal(0.0, 1.0);
    denom += tmp * tmp;
  }
  return numer * sqrt(variance * df / denom) + mean;
}

int power(int base, int exp)
{
  int i, sol;

  sol = 1;
  for(i = 0; i < exp; i++)
    sol *= base;
  return sol;
}




